org.apache.maven.scm.provider.accurev

## Class AccuRevScmProviderRepository

- java.lang.Object
- - org.apache.maven.scm.provider.ScmProviderRepository
  - - org.apache.maven.scm.provider.ScmProviderRepositoryWithHost
    - - org.apache.maven.scm.provider.accurev.AccuRevScmProviderRepository

    public class AccuRevScmProviderRepository
    extends ScmProviderRepositoryWithHost

### Field Summary

Fields
`static String` `DEFAULT_TAG_FORMAT`

### Constructor Summary

Constructors
Constructor and Description
`AccuRevScmProviderRepository()`

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`static String` `formatTimeSpec(Date when)`
`AccuRev` `getAccuRev()`
`AccuRevVersion` `getAccuRevVersion(ScmVersion scmVersion)`
`String` `getCheckoutRelativePath()` The relative path of the directory of the checked out project in comparison to the checkout directory, or an empty String in case the checkout directory equals the project directory.
`String` `getDepotRelativeProjectPath()`
`Transaction` `getDepotTransaction(String stream, String tranSpec)`
`String` `getDepotTransactionId(String stream, String tranSpec)`
`String` `getExportRelativePath()` Relative project path for export
`String` `getProjectPath()`
`String` `getRevision(String streamName, Date date)`
`String` `getRevision(String stream, long fromTranId)`
`String` `getRevision(String streamName, String transaction)`
`String` `getSnapshotName(String tagName)`
`String` `getStreamName()`
`String` `getTagFormat()`
`String` `getWorkSpaceRevision(String workspace)`
`boolean` `isWorkSpaceRoot(AccuRevInfo info)`
`boolean` `isWorkSpaceTop(AccuRevInfo info)`
`void` `setAccuRev(AccuRev accurev)`
`void` `setCheckoutRelativePath(String checkoutRelativePath)`
`void` `setLogger(ScmLogger logger)`
`void` `setProjectPath(String projectPath)`
`void` `setShouldUseExportForNonPersistentCheckout(boolean shouldUseExportForNonPersistentCheckout)`
`void` `setStreamName(String streamName)`
`void` `setTagFormat(String tagFormat)`
`boolean` `shouldUseExportForNonPersistentCheckout()` When checkout is not expected to be refreshed or committed, should export be used instead? Perforce, Clearcase and AccuRev store their meta-data about file status within the server rather than files in the source tree.
`String` `toString()`

### Methods inherited from class org.apache.maven.scm.provider.ScmProviderRepositoryWithHost

`getHost, getPassphrase, getPort, getPrivateKey, setHost, setPassphrase, setPort, setPrivateKey`

### Methods inherited from class org.apache.maven.scm.provider.ScmProviderRepository

`getParent, getPassword, getRelativePath, getUser, getWorkItem, isPersistCheckout, isPushChanges, setPassword, setPersistCheckout, setPushChanges, setUser, setWorkItem`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Field Detail

#### DEFAULT_TAG_FORMAT

    public static final String DEFAULT_TAG_FORMAT

See Also:
  Constant Field Values

### Constructor Detail

#### AccuRevScmProviderRepository

    public AccuRevScmProviderRepository()

### Method Detail

#### getTagFormat

    public String getTagFormat()

#### setTagFormat

    public void setTagFormat(String tagFormat)

#### getStreamName

    public String getStreamName()

#### setStreamName

    public void setStreamName(String streamName)

#### getProjectPath

    public String getProjectPath()

#### setProjectPath

    public void setProjectPath(String projectPath)

#### getAccuRev

    public AccuRev getAccuRev()

#### setAccuRev

    public void setAccuRev(AccuRev accurev)

#### isWorkSpaceRoot

    public boolean isWorkSpaceRoot(AccuRevInfo info)

Parameters:
  `info` -
Returns:
  true if info indicates a root of the workspace.

#### isWorkSpaceTop

    public boolean isWorkSpaceTop(AccuRevInfo info)

#### setLogger

    public void setLogger(ScmLogger logger)

#### getCheckoutRelativePath

    public String getCheckoutRelativePath()

The relative path of the directory of the checked out project in comparison to the checkout directory, or an empty String in case the checkout directory equals the project directory.

With most SCMs, this is just an empty String, meaning that the checkout directory equals the project directory. But there are cases (e.g. ClearCase) where within the checkout directory, the directory structure of the SCM system is repeated. E.g. if you check out the project "my/project" to "/some/dir", the project sources are actually checked out to "some/dir/my/project". In this example, relativePathProjectDirectory would contain "my/project".

#### setCheckoutRelativePath

    public void setCheckoutRelativePath(String checkoutRelativePath)

#### getExportRelativePath

    public String getExportRelativePath()

Relative project path for export

Returns:
  default same as `getCheckoutRelativePath()`

#### shouldUseExportForNonPersistentCheckout

    public boolean shouldUseExportForNonPersistentCheckout()

When checkout is not expected to be refreshed or committed, should export be used instead? Perforce, Clearcase and AccuRev store their meta-data about file status within the server rather than files in the source tree. This makes checkouts within checkouts (eg release:perform) difficult. Typically there is a way to do a lightweight export instead which can be implemented as the "export" command. This is a hint to downstream applications that "export" is available and should be used in preference to "checkout" in cases where "update" and "commit" are not intended to be used. (ie release:perform)

Returns:
  false by default

#### setShouldUseExportForNonPersistentCheckout

    public void setShouldUseExportForNonPersistentCheckout(boolean shouldUseExportForNonPersistentCheckout)

#### getDepotRelativeProjectPath

    public String getDepotRelativeProjectPath()

#### getAccuRevVersion

    public AccuRevVersion getAccuRevVersion(ScmVersion scmVersion)

#### getSnapshotName

    public String getSnapshotName(String tagName)

#### getRevision

    public String getRevision(String streamName,
                              Date date)

#### getRevision

    public String getRevision(String stream,
                              long fromTranId)

#### getRevision

    public String getRevision(String streamName,
                              String transaction)

#### getWorkSpaceRevision

    public String getWorkSpaceRevision(String workspace)
                                throws AccuRevException

Throws:
  `AccuRevException`

#### getDepotTransaction

    public Transaction getDepotTransaction(String stream,
                                           String tranSpec)
                                    throws AccuRevException

Throws:
  `AccuRevException`

#### getDepotTransactionId

    public String getDepotTransactionId(String stream,
                                        String tranSpec)
                                 throws AccuRevException

Throws:
  `AccuRevException`

#### toString

    public String toString()

Overrides:
  `toString` in class `Object`

#### formatTimeSpec

    public static String formatTimeSpec(Date when)